git@vger.kernel.org mailing list mirror (one of many)
 help / color / mirror / code / Atom feed
From: Jon Seymour <jon.seymour@gmail.com>
To: git@vger.kernel.org
Cc: gitster@pobox.com, j6t@kdbg.org, Jon Seymour <jon.seymour@gmail.com>
Subject: [PATCH v4 6/9] stash: teach git stash branch to tolerate stash-like arguments
Date: Tue, 10 Aug 2010 10:04:45 +1000	[thread overview]
Message-ID: <1281398688-21008-7-git-send-email-jon.seymour@gmail.com> (raw)
In-Reply-To: <1281242771-24764-1-git-send-email-jon.seymour@gmail.com>

This patch teaches git stash branch to tolerate stash-like arguments.

In particular, a stash is only required if an argument isn't specified
and the stash is only dropped if a stash entry reference was
specified or implied.

Signed-off-by: Jon Seymour <jon.seymour@gmail.com>
---
 git-stash.sh |   15 +++++++++++----
 1 files changed, 11 insertions(+), 4 deletions(-)

diff --git a/git-stash.sh b/git-stash.sh
index 86cd446..97e3749 100755
--- a/git-stash.sh
+++ b/git-stash.sh
@@ -390,20 +390,27 @@ drop_stash () {
 }
 
 apply_to_branch () {
-	have_stash || die 'Nothing to apply'
-
 	test -n "$1" || die 'No branch name specified'
 	branch=$1
 
 	if test -z "$2"
 	then
 		set x "$ref_stash@{0}"
+		have_stash || die 'Nothing to apply'
 	fi
 	stash=$2
 
+	assert_stash_like "$stash"
+
 	git checkout -b $branch $stash^ &&
-	apply_stash --index $stash &&
-	drop_stash $stash
+	apply_stash --index $stash
+
+	if is_stash_ref "$stash"
+	then
+		drop_stash "$stash"
+	else
+		true
+	fi
 }
 
 # The default command is "save" if nothing but options are given
-- 
1.6.5.rc3.8.g8ba5e

  parent reply	other threads:[~2010-08-10  0:06 UTC|newest]

Thread overview: 30+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2010-08-08  4:46 [PATCH v3 0/9] stash: modifiy handling of stash-like references Jon Seymour
2010-08-08  4:46 ` [PATCH v3 1/9] stash: refactor - create pop_stash function Jon Seymour
2010-08-08  4:46 ` [PATCH v3 2/9] stash: extract stash-like check into its own function Jon Seymour
2010-08-08  4:46 ` [PATCH v3 3/9] stash: introduce is_stash_ref and assert_stash_ref functions Jon Seymour
2010-08-08  4:46 ` [PATCH v3 4/9] stash: teach git stash pop to fail early if the argument is not a stash ref Jon Seymour
2010-08-08  4:46 ` [PATCH v3 5/9] stash: teach git stash drop to fail early if the specified revision is not a stash reference Jon Seymour
2010-08-08  4:46 ` [PATCH v3 6/9] stash: teach git stash branch to tolerate stash-like arguments Jon Seymour
2010-08-08  4:46 ` [PATCH v3 7/9] stash: teach git stash show to always " Jon Seymour
2010-08-08  4:46 ` [PATCH v3 8/9] t3903-stash.sh: tests of git stash with " Jon Seymour
2010-08-08  9:32   ` Johannes Sixt
2010-08-08 12:56     ` Jon Seymour
2010-08-08  4:46 ` [PATCH v3 9/9] Documentation: git stash branch now tolerates non-stash references Jon Seymour
2010-08-08 13:18   ` Jon Seymour
2010-08-10  0:04 ` [PATCH v4 0/9] stash: modifiy handling of stash-like references Jon Seymour
2010-08-10  0:04 ` [PATCH v4 1/9] stash: refactor - create pop_stash function Jon Seymour
2010-08-10  0:04 ` [PATCH v4 2/9] stash: extract stash-like check into its own function Jon Seymour
2010-08-13  0:49   ` Junio C Hamano
2010-08-13 23:55     ` Jon Seymour
2010-08-10  0:04 ` [PATCH v4 3/9] stash: introduce is_stash_ref and assert_stash_ref functions Jon Seymour
2010-08-13  0:49   ` Junio C Hamano
2010-08-14  0:26     ` Jon Seymour
2010-08-10  0:04 ` [PATCH v4 4/9] stash: teach git stash pop to fail early if the argument is not a stash ref Jon Seymour
2010-08-10  0:04 ` [PATCH v4 5/9] stash: teach git stash drop to fail early if the specified revision is not a stash reference Jon Seymour
2010-08-10  0:04 ` Jon Seymour [this message]
2010-08-10  0:04 ` [PATCH v4 7/9] stash: teach git stash show to always tolerate stash-like arguments Jon Seymour
2010-08-13  0:49   ` Junio C Hamano
2010-08-10  0:04 ` [PATCH v4 8/9] t3903-stash.sh: tests of git stash with " Jon Seymour
2010-08-10  0:04 ` [PATCH v4 9/9] Documentation: git stash branch now tolerates non-stash references Jon Seymour
2010-08-13  0:49   ` Junio C Hamano
2010-08-14  0:30     ` Jon Seymour

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

  List information: http://vger.kernel.org/majordomo-info.html

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1281398688-21008-7-git-send-email-jon.seymour@gmail.com \
    --to=jon.seymour@gmail.com \
    --cc=git@vger.kernel.org \
    --cc=gitster@pobox.com \
    --cc=j6t@kdbg.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
Code repositories for project(s) associated with this public inbox

	https://80x24.org/mirrors/git.git

This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox;
as well as URLs for read-only IMAP folder(s) and NNTP newsgroup(s).